<?php
namespace nur\sery\php\time;

use DateTimeZone;
use PHPUnit\Framework\TestCase;

class DateTest extends TestCase {
  protected static function dt(string $datetime): Date {
    return new Date($datetime, new DateTimeZone("Indian/Reunion"));
  }

  function testDate() {
    $date = self::dt("2024-04-05 09:15:23");

    self::assertSame("05/04/2024", $date->format());
    self::assertSame("05/04/2024", strval($date));
    self::assertSame(2024, $date->year);
    self::assertSame(4, $date->month);
    self::assertSame(5, $date->day);
    self::assertSame(0, $date->hour);
    self::assertSame(0, $date->minute);
    self::assertSame(0, $date->second);
    self::assertSame(5, $date->wday);
    self::assertSame(14, $date->wnum);
    self::assertSame("+04:00", $date->timezone);
    self::assertSame("05/04/2024 00:00:00", $date->datetime);
    self::assertSame("05/04/2024", $date->date);
  }

  function testClone() {
    $date = self::dt("now");
    $clone = Date::clone($date);
    self::assertInstanceOf(DateTime::class, $clone);
  }
}
